package client;

class Task {

	private long storedTime;
	private final long delay;
	private final Runnable task;
	
	Task(long delay, Runnable task) {
		assert delay > 0;
		assert task != null;
		
		this.delay = delay;
		this.task = task;
		this.storedTime = System.currentTimeMillis();
	}
	
	boolean check() {
		long currentTime = System.currentTimeMillis();
		if (currentTime - storedTime > delay) {
			storedTime = currentTime;
			task.run();
			return true;
		} else
			return false;
	}
}
