/**
 * 
 */
package client.messages;

/**
 * @author turalb
 * 
 * The cancel message is fixed length, and is used to cancel block requests. 
 * The payload is identical to that of the "request" message. 
 * 
 * It is typically used during "End Game."
 *
 */
public class CancelRequest extends Message {
	private static final long serialVersionUID = 5601762487546481442L;
	
	/** integer specifying the zero-based piece index */
	public int index;	
	/** integer specifying the zero-based byte offset within the piece */ 
	public int begin;	
	/** integer specifying the requested length */
	public int length;
	
	public CancelRequest(int index, int begin, int length) {
		this.index = index;
		this.begin = begin;
		this.length = length;
	}
	
	/**
	 * 
	 * @param index
	 * Sets the index field to index
	 */
	public void setIndex(int index) {
		this.index = index;
	}
	
	/**
	 * 
	 * @param begin
	 * Sets the begin field to begin
	 */
	public void setBegin(int begin) {
		this.begin = begin;
	}
	
	/**
	 * 
	 * @param length
	 * Sets the length field to length
	 */
	public void setLength(int length) {
		this.length = length;
	}
}
