/**
 * 
 */
package client.messages;

/**
 * @author turalb
 * 
 * The piece message is variable length, where X is the length of the block. 
 * The payload contains the following information:
 * 
 *  index: integer specifying the zero-based piece index
 *	begin: integer specifying the zero-based byte offset within the piece
 * 	block: block of data, which is a subset of the piece specified by index. 
 *
 */
public class ChunkReply extends Message {
	private static final long serialVersionUID = -6832375049552672999L;
	
	/** integer specifying the zero-based piece index */
	public int pieceIndex;
	/** integer specifying the zero-based byte offset within the piece */
	public int chunkIndex;
	/** the data this message is holding */
	public String block;			
	
	@Override
	public String toString() {
		return "[ chunk " + chunkIndex + " in piece " + pieceIndex + " = " + block.hashCode() + "]";
	}
}
