/**
 * 
 */
package client.messages;

import java.util.HashSet;
import java.util.Set;

/**
 * @author turalb
 * 
 * The have message is fixed length. The payload is the zero-based index of a piece that 
 * has just been successfully downloaded and verified via the hash.
 *
 */
public class HaveMessage extends Message {
	private static final long serialVersionUID = -6693000223399423846L;
	
	/** integer specifying the zero-based piece index */
	public Set<Integer> indexes;

	public HaveMessage(Set<Integer> indexes) {
		this.indexes = new HashSet<Integer>(indexes);
	}
	
	
	@Override
	public String toString() {
		return "[" + this.sourceName + " says they have " + indexes + "]";
	}
}

