package simulation;

public class Constants {

	// GUI?
	public static final boolean GUI = true;
	
	public static final int NUM_CLIENTS = 8; 
	
	// Runseeder parameters
	public static int NUM_SEEDERS = 5;
	public static int NUM_LEECHERS = 45;
	public static int SIM_NUM_PIECES = 20;
	
	// Tracker host
	public static final String TRACKER_HOST = "localhost";
	public static final int TRACKER_PORT = 1337;
	
	// number of peers in tracker's reply
	public static final int NEIGHBOURS_REPLY = 3;
	
	public static final int MULTIPLIER = 100;
	
	// number of parallel chunk requests
	public final static int BATCH = 8;
	
	// number of parallel piece download sessions
	public final static int PARALLEL_SESSIONS = 5;
	
	// timeout of a download session
	public final static long DOWNLOAD_SESSION_TIMEOUT = 15000;	
	
	// timeout of a download session assuming the peer is choking
	public final static long FAST_SESSION_TIMEOUT = 5000;
	
	/** if enabled, uses forwarding strategy, otherwise, uses default bittorrent-like strategy*/
	public final static boolean FORWARDING = false;
	
	// period of averaging in statistics
	public static final long MOVING_AVERAGE_PERIOD = 5000;
	
	// simulate network latency?
	public static final boolean LATENCY = true;
	
	/** upload rate moving average */
	public static final long UPLOAD_AVERAGE_PERIOD = 20000;
	
	/** the size of a piece in bytes = 512*1024 = 524288 */
	public static final int PIECE_SIZE = 3200;// 512*Constants.MULTIPLIER;

	/** the size of a chunk in bytes = 16*1024 */
	public static final int CHUNK_SIZE = 100;// 16*Constants.MULTIPLIER;

	/** pieces always contain 512*1024/(16*1024) = 32 chunks */
	public static final int NUM_OF_CHUNKS = PIECE_SIZE / CHUNK_SIZE;
	
	/** TCP or UDP for tracker */
	public static final boolean USE_TCP = true;
}
