package simulation;

import java.util.Random;
import java.util.Set;

import client.LatencyEmulator;

public class PartitionEmulator implements LatencyEmulator {

	private final Set<Integer> part1;
	private final Set<Integer> part2;
	private final Random random = new Random();
	
	PartitionEmulator (Set<Integer> part1, Set<Integer> part2) {
		this.part1 = part1;
		this.part2 = part2;
	}
	
	@Override
	public long sleep(int from, int to) {
		assert part1.contains(from) || part2.contains(from);
		assert part1.contains(to) || part2.contains(to);
		
		if (part1.contains(from) && part1.contains(to))
			return 10 + random.nextInt(10);
		
		if (part2.contains(from) && part2.contains(to))
			return 10 + random.nextInt(10);

		return 80 + random.nextInt(20);
	}

	@Override
	public String toString() {
		return "PART1 " + part1 + "\n" + "PART2 " + part2;
	}
}
