package simulation;

import java.util.ArrayList;
import java.util.HashSet;
import java.util.List;
import java.util.Random;
import java.util.Set;

import tracker.TCPTracker;
import tracker.UDPTracker;
import util.File;
import client.GUI;
import client.Peer;

import common.Server;

public class RunPartitions {

	public static void main(String[] args) {

		GUI gui = Constants.GUI ? new GUI() : null;

		Set<Peer> clientSet = new HashSet<Peer>();
		Set<Integer> portsSet = new HashSet<Integer>();

		Random rand = new Random();
		while (portsSet.size() < simulation.Constants.NUM_CLIENTS) {
			int i = rand.nextInt(60000) + 4000;
			portsSet.add(i);
		}

		if (Constants.USE_TCP)
			new TCPTracker(simulation.Constants.TRACKER_PORT);
		else
			new UDPTracker(simulation.Constants.TRACKER_PORT);

		File FILE = File
				.generateRandomFile(Constants.SIM_NUM_PIECES, "FILE_10");

		List<Integer> portsList = new ArrayList<Integer>(portsSet);
		
		// set up emulation
		Set<Integer> part1 = new HashSet<Integer>();
		Set<Integer> part2 = new HashSet<Integer>();

		for (int i = 0; i < simulation.Constants.NUM_CLIENTS / 2; i++) {
			part1.add(portsList.get(i));
		}

		for (int i = simulation.Constants.NUM_CLIENTS / 2; i < simulation.Constants.NUM_CLIENTS; i++) {
			part2.add(portsList.get(i));
		}

		Server.setEmulator(new PartitionEmulator(part1, part2));
		
		for (int i = 2; i < simulation.Constants.NUM_CLIENTS; i++) {
			Peer tempPeer = new Peer(portsList.get(i), simulation.Constants.TRACKER_HOST,
					simulation.Constants.TRACKER_PORT, new File[] { FILE.getEmptyFile() });
			clientSet.add(tempPeer);
		}

		for (int i = 0; i < 2; i++) {
			Peer seeder = new Peer(portsList.get(i),
					simulation.Constants.TRACKER_HOST,
					simulation.Constants.TRACKER_PORT, new File[] { FILE });
			clientSet.add(seeder);
		}

		for (Peer client : clientSet) {
			if (Constants.GUI)
				gui.add(client);
		}
	}
}
