package simulation;

import java.util.ArrayList;
import java.util.HashSet;
import java.util.List;
import java.util.Random;
import java.util.Set;

import util.File;
import util.ThreadUtil;
import client.GUI;
import client.Peer;

public class RunSeeders {
	
	public static void main(String[] args) {
		GUI gui = Constants.GUI ? new GUI() : null;
		
		Set<Integer> portsSet = new HashSet<Integer>();
		
		Random rand = new Random();
		while (portsSet.size() < Constants.NUM_SEEDERS + Constants.NUM_LEECHERS) {
			int i = rand.nextInt(60000) + 4000;
			portsSet.add(i);			
		}
		
		List<Integer> ports = new ArrayList<Integer>(portsSet);

		File file = File.generateRandomFile(Constants.SIM_NUM_PIECES, "FILE_10");
		
		// generate leechers
		for (int i = Constants.NUM_SEEDERS; i < Constants.NUM_SEEDERS + Constants.NUM_LEECHERS; i++) {
			Peer tempPeer = new Peer(ports.get(i), Constants.TRACKER_HOST, Constants.TRACKER_PORT, file.getEmptyFile());
			if (Constants.GUI) gui.add(tempPeer);
			ThreadUtil.sleep();
		}
		
		// rest partial seeders
		for (int i = 1; i < Constants.NUM_SEEDERS; i++) {
			Peer tempPeer = Peer.generatePeer(ports.get(i), Constants.TRACKER_HOST, Constants.TRACKER_PORT, file);
			if (Constants.GUI) gui.add(tempPeer);
			ThreadUtil.sleep();
		}
		
		// one full seeder
		Peer seeder = new Peer(ports.get(0), Constants.TRACKER_HOST, Constants.TRACKER_PORT, file);
		if (Constants.GUI) gui.add(seeder);
		ThreadUtil.sleep();
	}
}
