package tracker;

import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.net.ServerSocket;
import java.net.Socket;

import util.Serializer;

/**
 * TCP implementation.
 * 
 * @author kuat
 * 
 */
public class TCPTracker extends AbstractTracker {

	public TCPTracker(int port) {
		// Create a server socket to accept client connection requests
		final ServerSocket socket;
		try {
			socket = new ServerSocket(port);
		} catch (IOException e1) {
			throw new Error();
		}

		new Thread(new Runnable() {
			public void run() {
				while (true) { 
					try {
						Socket clntSock = socket.accept(); 

						InputStream in = clntSock.getInputStream();
						OutputStream out = clntSock.getOutputStream();

						byte[] data = new byte[1024 * 5];
						in.read(data);
						String host = clntSock.getInetAddress().getHostAddress();						
						byte[] buf = Serializer.write(process(Serializer.read(data), host));
						out.write(buf);
						out.close();
						
						clntSock.close(); 
					} catch (IOException e) {
						e.printStackTrace();
					}
				}
			}
		}).start();
	}

	@Override
	public void process(byte[] bb, String host, int port) {
	}
}
