package tracker;

import java.io.IOException;
import java.net.Socket;
import java.net.UnknownHostException;

public class TCPTrackerClient extends TrackerClient {
	private final String host;
	private final int port;

	public TCPTrackerClient(String host, int trackerPort) throws IOException {
		this.host = host;
		this.port = trackerPort;
	}

	protected final byte[] send(byte[] buf) throws IOException {		
		try {
			Socket socket = new Socket(host, port);
			socket.getOutputStream().write(buf);
			int len = 1024*5;
			byte[] result = new byte[len];
			while(socket.getInputStream().read(result) != -1){}
			return result;
		} catch (UnknownHostException e) {
			e.printStackTrace();
		}
		return null;
	}
}
