package tracker;

import java.io.IOException;

import util.Serializer;

import common.UDPServer;

/**
 * Main class for the tracker.
 * @author kuat
 *
 */
public class UDPTracker extends AbstractTracker {
	private final UDPServer server;
	
	public UDPTracker (int port) {
		System.out.println("Tracker starting at " + port);
		
		// start a server
		try {
			server = new UDPServer(port, this);
		} catch (IOException e) {
			e.printStackTrace();
			System.err.println("could not create a UDP server for port " + port);
			throw new Error();
		}	
	}

	public void process(byte[] data, String host, int port) {
		try {
			byte[] buf = Serializer.write(process(Serializer.read(data), host));
			server.send(buf, host, port);
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
}
