package util;

import java.util.Arrays;
import java.util.Collection;
import java.util.HashSet;
import java.util.Iterator;
import java.util.List;
import java.util.Random;
import java.util.Set;
public final class RandomUtil {

	private static final Random random = new Random();
	
	public static <T> T getRandom(Collection<T> col) {
		assert col != null && col.size() > 0;
		
		int k = random.nextInt(col.size());
		
		Iterator<T> it = col.iterator(); 
		for (int i = 0; i < k; i++) it.next();
			
		return it.next();
	}
	
	public static <T> T getRandom(List<T> list) {
		assert list != null && list.size() > 0;
	
		return list.get(random.nextInt(list.size()));			 
	}
	
	public static <T> Set<T> getRandom(List<T> list, int n) {
		assert n >= 1;
		
		if (list.size() <= n) {
			return new HashSet<T>(list);
		} else {
			Set<T> set = new HashSet<T>();	
			
			while (set.size() < n) {
				set.add(getRandom(list));
			}
			
			return set;
		}
	}
	
	public static void main (String[] args) {
		System.out.println(getRandom(Arrays.asList()));
	}
}
