package util;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.io.Serializable;

/**
 * Static routines.
 * 
 * @author kuat
 *
 */
public class Serializer {

	public static Object read(InputStream is) {
		assert is != null;

		try {
			return new ObjectInputStream(is).readObject();
		} catch (Exception e){
			System.err.println("failed to deserialize");
			e.printStackTrace();
			assert false;
			return null;
		}		
	}
	
	public static Object read(byte[] data) {
		assert data != null; 
		
		return read(new ByteArrayInputStream(data));
	}
	
	public static byte[] write(Serializable o) {
		assert o != null;
		
		try {
			ByteArrayOutputStream out = new ByteArrayOutputStream();
			new ObjectOutputStream(out).writeObject(o);
			return out.toByteArray();
		} catch (IOException e) {
			System.err.println("failed to serialize " + o);		
			e.printStackTrace();
			return null;
		}		
	}
}
