package util;

import java.util.Random;

public class ThreadUtil {

	/** amount of time to use for adaptive sleep */
	private static final long SLEEP_INTERVAL = 10;

	private static final Random random = new Random();

	private static long storedTime = System.currentTimeMillis();

	public static void sleep() {
		long currentTime = System.currentTimeMillis();
		long difference = currentTime - storedTime;
		if (difference > SLEEP_INTERVAL)
			difference = SLEEP_INTERVAL; // ensures we do not try to sleep
											// for a negative amount of time
		sleep(SLEEP_INTERVAL - difference);
		storedTime = System.currentTimeMillis();
	}

	public static void sleep(long timeout) {
		try {
			Thread.sleep(timeout);
		} catch (InterruptedException e) {
			e.printStackTrace();
		}
	}

	public static void fastSleep() {
		sleep(5);
	}
	
	public static void randomSleep(int a, int b) {
		sleep(a + random.nextInt(b));
	}
}
